<?php

function _phpbb_sso_check_user($username, $password) {
    global $db, $config;

    if (!($users_table = phpbb_get_table('users')))
        return;

    $results = db_query("SELECT user_id, user_password, user_type
                         FROM {$users_table}
                         WHERE username_clean = :username", array(':username' => $username));

    if (!$results->rowCount())
        return false;

    $user_types = array('USER_NORMAL', 'USER_INACTIVE', 'USER_IGNORE', 'USER_FOUNDER');

    module_load_include('inc', 'phpbb_sso', 'phpbb_sso.hash');
    foreach ($results as $row) {
        if (!phpbb_sso_check_hash($password, $row->user_password))
            continue;

        // Check for old password hash
        if (strlen($row->user_password) == 32) {
            $hash = phpbb_sso_hash($password);

            // Update the password in the users table to the new format
            db_query("UPDATE {$users_table} SET user_password = :user_password, user_pass_convert = 0 WHERE user_id = :user_id", array(':user_password' => $hash, ':user_id' => $row->user_id));
        }

        // Is the account inactive?
        switch ($user_types[$row->user_type]) {
            case 'USER_INACTIVE':
            case 'USER_IGNORE':
                return false;
        }

        return true;
    }

    return false;
}
